/* Programmierung Paralleler Prozesse
   Projekt-Aufgabe 1.1
   ######################################
   Michael Lahl, Matthias Jauernig, 03IN
   ######################################
   Multiplikation von Matrix und Vektor
   Master-Programm
*/

#include </usr/local/share/solaris/pvm3/include/pvm3.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

void erzeugePerZufall  (int ***A, int **B, int *m, int *n);
void leseVonTastaturEin(int ***A, int **B, int *m, int *n);
void leseVonDateiEin   (int ***A, int **B, int *m, int *n);
void speichereInDatei  (int  **A, int  *B, int  m, int  n);

int main(void){
    int i, j, mytid, numt, *tids, *tmpTids;
    int **A=NULL, *B, *C, m, n, wahl;
    int rowsPerSlave, rowsForParent, slaves;
    
    /* Hauptmen anzeigen */
    do{
      printf(	"Option waehlen:\n"
    		"---------------\n\n");
      printf("(1) Daten per Zufallsgenerator erzeugen\n");
      printf("(2) Daten eingeben\n");
      printf("(3) Daten von Datei einlesen\n");
      printf("> ");
      scanf("%d",&wahl);
    
      switch(wahl){
          case 1:
	      erzeugePerZufall(&A,&B,&m,&n);
	      break;
	  case 2:
	      leseVonTastaturEin(&A,&B,&m,&n);
	      break;
	  case 3:
	      leseVonDateiEin(&A,&B,&m,&n);
	      break;
	  default:
	      printf("Ungueltige Eingabe...\n\n");
	      break;
      }
    }while(wahl<1 || wahl>3);
    printf("Matrixdimensionen: m=%d, n=%d\n",m,n);

    if(m<=12){
        // Ausgangsmatrix ausgeben
        printf("Ausgangsmatrix A:\n-----------------\n");
        for(i=0; i<m; i++){
	    for(j=0; j<n; j++)
	        printf("%d, ",A[i][j]);
            printf("\b\b  \n");
	}
	// Vektor B ausgeben
        printf("\nVektor B:\n---------\n");
	for(j=0; j<n; j++)
	    printf("%d\n",B[j]);
	printf("\n");
    }
    

    //if(wahl!=3)
    //   speichereInDatei(A,B,m,n);
    // Slaves eingeben lassen
    printf("Wieviele Slaves sollen gestartet werden (max. %d)?: ", m-1);
    scanf("%d",&slaves);
    if(slaves > m-1)
        slaves = m-1;

    C = (int*) malloc(m*sizeof(int));

    /*  enroll this program in pvm 3 */
    mytid = pvm_mytid();
    if( mytid<0 ){
       printf("Error in pvm_mytid   error= %x\n", mytid);
       exit(0);
    }
    else
       printf("My task id is %x\n", mytid);

    /*  try to start up slaves slave-programms */
    tids = (int*) malloc((slaves)*sizeof(int));
    numt = pvm_spawn( "slave3", (char**)0, 0, "", slaves, tids);
    if( numt == 0 ){
      printf("Es konnten keine Slaves gestartet werden.\n");
      exit(1);
    }
    else if ( numt<0 ){
        printf("Error in pvm_spawn (numt)  error = %d\n", numt);
	exit(1);
    }
    else
        printf("Es wurden %d slaves (tasks) gestartet\n", numt);
	
    /* neuen tids-Vektor anlegen fr tatschlich gestartete Slaves */
    if(numt != slaves){
        tmpTids = (int*)malloc(numt*sizeof(int));
        for(i=0; i<numt; i++)
            tmpTids[i] = tids[i];
        free(tids);
        tids = tmpTids;
    }
    
    /* schauen, ob Fehler in spawn aufgetreten sind */
    for(i=0; i<numt; i++){
        if(tids[i]<0)
            printf("Error in pvm_spawn (tid(%d))  error = %x\n", i, tids[i]);
        else
            printf("task id fuer slave  %d: %x\n", i, tids[i]);
    }
    /* Zeilen berechnen, welche jeweils an slaves gesendet werden sollen */
    rowsPerSlave  = m/numt;
    rowsForParent = m%numt;
    printf("Pro Slave %d Zeilen...\n",rowsPerSlave);
    printf("Zeilen fuer Parent: %d\n",rowsForParent);
    
    /* Daten an slaves senden */
    for(i=0; i<numt; i++){
        printf("Sende an Slave %d.\n",i);
        // n senden
        pvm_initsend( PvmDataRaw );
        pvm_pkint( &n, 1, 1 );
        //pvm_send( tids[i], 1 );
        // Zeilen pro Slave senden
        //pvm_initsend( PvmDataRaw );
        pvm_pkint( &rowsPerSlave, 1, 1 );
        //pvm_send( tids[i], 2 );
        // Zeilen aus A senden
        for(j=0; j<rowsPerSlave; j++){
            //pvm_initsend( PvmDataRaw );
            pvm_pkint( &A[i*rowsPerSlave+j][0], n, 1);
            //pvm_send( tids[i], 3 );
        }
        // B senden
        //pvm_initsend( PvmDataRaw );
        pvm_pkint( &B[0], n, 1);
        pvm_send( tids[i], 4 );
    }

    /* Restzeilen selber berechnen */
    printf("Berechne die letzten %d Matrixzeilen selbst.\n", rowsForParent);
    for(i=0; i<rowsForParent; i++){
        C[rowsPerSlave*numt+i] = 0;
	for(j=0; j<n; j++){
            C[rowsPerSlave*numt+i] += A[rowsPerSlave*numt+i][j]*B[j];
        }
    }

    /* auf Ergebnisse der Slaves warten */
    for(i=0; i<numt; i++){
        printf("Warte auf Erhalt der Daten von Slave %d... ",i);
        pvm_recv( tids[i], 5 );
        pvm_upkint( &C[rowsPerSlave*i], rowsPerSlave, 1 );
        printf("Daten erhalten.\n");
    }
    
    /* empfangene Loesung ausgeben */
    printf("\nLoesungsvektor C:\n-----------------\n");
    for(i=0; i<m; i++){
        printf("%d\n", C[i]);
    }

    pvm_exit();
    return 0;
}


void erzeugePerZufall(int ***A, int **B, int *m, int *n){
    int i, j;
    
    // Zufallsgenerator initialisieren
    srand(time(NULL));
    *n = rand()%10+2;
    *m = rand()%10+2;
    
    // Matrix A erzeugen und Vektor B
    *A = (int**)malloc(*m*sizeof(int*));
    *B = (int*)malloc(*n*sizeof(int));
    for(i=0; i<*m; i++){
        (*A)[i] = (int*)malloc(*n*sizeof(int));
        for(j=0; j<*n; j++){
	    (*A)[i][j] = rand()%100;
	    if(i==0)
	        (*B)[j] = rand()%100;
	}
    }
}

void leseVonTastaturEin(int ***A, int **B, int *m, int *n){
    int i, j;
    
    // Dimensionen einlesen
    printf("Dimension m eingeben: ");
    scanf("%d",m);
    printf("Dimension n eingeben: ");
    scanf("%d",n);
    
    // Speicher zuweisen und Matrix A einlesen
    printf("\nMatrix A eingeben:\n");
    *A = (int**)malloc(*m*sizeof(int*));
    for(i=0; i<*m; i++){
        (*A)[i] = (int*)malloc(*n*sizeof(int));
        for(j=0; j<*n; j++){
	    printf("A[%d][%d]?: ",i,j);
	    scanf("%d",&(*A)[i][j]);
	}
    }
    
    // Vektor B einlesen
    printf("\nVektor B eingeben:\n");
    *B = (int*)malloc(*n*sizeof(int));
    for(i=0; i<*n; i++){
    	printf("B[%d]?: ",i);
	scanf("%d",&(*B)[i]);
    }
}

void leseVonDateiEin(int ***A, int **B, int *m, int *n){
    FILE* fp = NULL;
    int i, j;
    char* filename = (char*)malloc(100);
   
    // Zu ffnende Datei einlesen
    printf("Datei angeben: ");
    scanf("%s",filename);
   
    // Datei ffnen
    fp = fopen(filename,"rb");
    if(fp == NULL){
        perror("Fehler beim ffnen der Datei");
        exit(1);
    }
   
    // Dimensionen aus Datei lesen
    if(!fscanf(fp,"%d",m)){
        printf("Fehler beim Lesen der Dimensionen von Datei.\n");
        exit(1);
    }
    if(!fscanf(fp,"%d",n)){
        printf("Fehler beim Lesen der Dimensionen von Datei.\n");
        exit(1);
    }

    // Matrix A einlesen
    *A = (int**)malloc(*m*sizeof(int*));
    for(i=0; i<*m; i++){
        (*A)[i] = (int*)malloc(*n*sizeof(int));
        for(j=0; j<*n; j++)
	    if(!fscanf(fp,"%d",&(*A)[i][j])){
	        printf("Fehler beim Lesen von Matrix A.\n");
                exit(1);
	    }
    }

    // Vektor B einlesen
    *B = (int*)malloc(*n*sizeof(int));
    for(i=0; i<*n; i++)
        if(!fscanf(fp,"%d",&(*B)[i])){
            printf("Fehler beim Lesen von Vektor B.\n");
            exit(1);
        }
}

void speichereInDatei(int **A, int *B, int m, int n){
    int i, j;
    FILE* fp = NULL;
    char* filename = (char*)malloc(100);
    
    // Zu schreibende Datei einlesen
    printf("Datei angeben: ");
    scanf("%s",filename);
    
    fp = fopen(filename,"wb");
    if(fp == NULL){
        perror("Fehler beim ffnen der Datei");
        exit(1);
    }
    
    // Dimensionen in Datei schreiben
    if(!fprintf(fp,"%d %d\n",m,n)){
        printf("Fehler beim Schreiben der Dimensionen in die Datei.\n");
        exit(1);
    }
        
    // Matrix A in Datei schreiben
    for(i=0; i<m; i++)
        for(j=0; j<n; j++)
	    if(!fprintf(fp,"%d ",A[i][j])){
	        printf("Fehler beim Schreiben von Matrix A.\n");
                exit(1);
	    }
    
    // Vektor B in Datei schreiben
    for(i=0; i<n; i++)
        if(!fprintf(fp,"%d ",B[i])){
            printf("Fehler beim Schreiben von Vektor B.\n");
            exit(1);
        }
}
